<template>
  <Modal
    :name="nameModal"
    :adaptive="true"
    :classes="classes"
    :width="widthModal"
    :scrollable="scrollable"
    height="auto"
    @before-open="$emit('before-open')"
    @opened="$emit('opened')"
    @before-close="$emit('before-close')">
    <slot name="body"/>
  </Modal>
</template>

<script>
export default {
  name: 'CheckAutoModal',
  props: {
    nameModal: {
      type: String,
      default: '',
    },
    widthModal: {
      type: Number,
      default: 600,
    },
    initClass: {
      type: String,
      default: '',
    },
    noHeader: {
      type: Boolean,
      default: false,
    },
    visible: {
      type: Boolean,
      default: false,
    },
    scrollable: {
      type: Boolean,
      default: true,
    },
  },
  computed: {
    classes() {
      return ['appModal', 'ui', 'modal', this.initClass];
    },
  },
  // TODO: Создаем новый модуль store для модалок. Заводим enum для типов этих модалок.
  // TODO: И все необходимые actions/mutations.
  watch: {
    visible(newValue) {
      if (newValue) {
        this.$modal.show(this.nameModal);
      } else {
        this.$modal.hide(this.nameModal);
      }
    },
  },
};
</script>

<style scoped lang="postcss">
  .--modal-open {
    overflow: hidden;
  }

  .v--modal-overlay {
    background-color: var(--bg-wrapper);
  }

  .appModal {
    display: block;
    padding: 0;
    width: 100%;
    max-width: 100vw;
    min-height: 4rem;
    max-height: 100%;
    border-radius: 0.25rem;
    background-color: var(--bg-main);
    box-shadow: 0 2px 8px rgba(0, 0, 0, .33);
    overflow-x: hidden;
    overflow-y: auto;

    &-header {
      position: relative;
      display: flex;
      align-items: center;
      padding: 0 3rem 0 1.625rem;
      width: 100%;
      height: 4.125rem;
      border-bottom: 1px solid var(--border-color-main);
      &._no-header {
        padding: 0;
        height: 0;
        border: none;
      }
    }

    &-title {
      display: block;
      text-align: center;
    }

    &-close-button {
      position: absolute;
      top: 0;
      right: 0;
      z-index: 10;
      display: block;
      padding: 1.25rem;
      background: none;
      border: none;
      outline: none;
      cursor: pointer;

      > .svg {
        width: 0.625rem;
        height: auto;
        fill: var(--fill-light);
        transition: fill 0.2s var(--transition-easeOutQuad);
      }

      &:hover, &:focus {
        > .svg {
          fill: var(--fill-main);
        }
      }
    }

    @media screen and (max-width: 1200px) and (min-width: 981px) {
      &-close-button > .svg {
        width: 1.25rem;
      }
    }

    @media screen and (max-width: 980px) {
      left: 0 !important;
      display: flex;
      flex-direction: column;
      align-items: center;
      margin-left: auto;
      margin-right: auto;
      width: 100%;
      max-width: 30rem;
      height: auto;
      border-radius: 0;

      &-header {
        justify-content: center;
        padding-top: 3rem;
        height: auto;
        text-align: center;
        border-bottom: none;
      }

      &-close-button > .svg {
        width: 1.25rem;
      }

      &-title {
        font-size: 1.375rem;
      }

      &-body {
        display: flex;
        flex-direction: column;
        flex-grow: 1;
        width: 100%;
        height: 100%;
      }

      &-footer {
        margin-top: auto;
      }
    }
  }
.checkAutoModal {
  .ui.modal>.header>.title {
    font-size: 1.125rem;
    line-height: 1.2;
    font-weight: 500;
    color: #272727;
  }

  .ui.modal>.close {
    cursor: pointer;
    position: absolute;
    top: 1.25rem !important;
    right: 1.25rem !important;
    z-index: 1;
    opacity: 1;
    font-size: 0;
    line-height: 0;
    background-image: url(data:image/svg+xml;base64,PD94bWwgdmVyc2lvbj0iMS4wIiBlbmNvZGluZz0idXRmLTgiP…AwLDExLjMgMC43LDEyIDYsNi43IDExLjMsMTIgMTIsMTEuMyA2LjcsNiAiLz4KPC9zdmc+Cg==);
    background-position: center;
    background-repeat: no-repeat;
    background-size: 0.75rem;
    background-color: transparent;
    width: 1.875rem;
    height: 1.875rem;
    padding: 0;
    outline: 0;
    border: 1px solid #EDEDED;
    border-radius: 50% !important;
    -webkit-transition: border-color 0.5s ease;
    transition: border-color 0.5s ease;
  }
}
</style>
